/* ValidationMessage.c generated by valac 0.54.8, the Vala compiler
 * generated from ValidationMessage.vala, do not modify */

/*
* Copyright 2018-2020 elementary, Inc. (https://elementary.io)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include <gtk/gtk.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <granite.h>
#include "online-accounts.h"

#define TYPE_VALIDATION_MESSAGE (validation_message_get_type ())
#define VALIDATION_MESSAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VALIDATION_MESSAGE, ValidationMessage))
#define VALIDATION_MESSAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VALIDATION_MESSAGE, ValidationMessageClass))
#define IS_VALIDATION_MESSAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VALIDATION_MESSAGE))
#define IS_VALIDATION_MESSAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VALIDATION_MESSAGE))
#define VALIDATION_MESSAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VALIDATION_MESSAGE, ValidationMessageClass))

typedef struct _ValidationMessage ValidationMessage;
typedef struct _ValidationMessageClass ValidationMessageClass;
typedef struct _ValidationMessagePrivate ValidationMessagePrivate;
enum  {
	VALIDATION_MESSAGE_0_PROPERTY,
	VALIDATION_MESSAGE_LABEL_PROPERTY,
	VALIDATION_MESSAGE_NUM_PROPERTIES
};
static GParamSpec* validation_message_properties[VALIDATION_MESSAGE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _ValidationMessage {
	GtkRevealer parent_instance;
	ValidationMessagePrivate * priv;
	GtkLabel* label_widget;
};

struct _ValidationMessageClass {
	GtkRevealerClass parent_class;
};

struct _ValidationMessagePrivate {
	gchar* _label;
};

static gint ValidationMessage_private_offset;
static gpointer validation_message_parent_class = NULL;

VALA_EXTERN GType validation_message_get_type (void) G_GNUC_CONST ;
VALA_EXTERN ValidationMessage* validation_message_new (const gchar* label);
VALA_EXTERN ValidationMessage* validation_message_construct (GType object_type,
                                                 const gchar* label);
VALA_EXTERN const gchar* validation_message_get_label (ValidationMessage* self);
VALA_EXTERN void validation_message_set_label (ValidationMessage* self,
                                   const gchar* value);
static GObject * validation_message_constructor (GType type,
                                          guint n_construct_properties,
                                          GObjectConstructParam * construct_properties);
static void validation_message_finalize (GObject * obj);
static GType validation_message_get_type_once (void);
static void _vala_validation_message_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec);
static void _vala_validation_message_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec);

static inline gpointer
validation_message_get_instance_private (ValidationMessage* self)
{
	return G_STRUCT_MEMBER_P (self, ValidationMessage_private_offset);
}

ValidationMessage*
validation_message_construct (GType object_type,
                              const gchar* label)
{
	ValidationMessage * self = NULL;
	g_return_val_if_fail (label != NULL, NULL);
	self = (ValidationMessage*) g_object_new (object_type, "label", label, NULL);
	return self;
}

ValidationMessage*
validation_message_new (const gchar* label)
{
	return validation_message_construct (TYPE_VALIDATION_MESSAGE, label);
}

const gchar*
validation_message_get_label (ValidationMessage* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_label;
	result = _tmp0_;
	return result;
}

void
validation_message_set_label (ValidationMessage* self,
                              const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = validation_message_get_label (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_label);
		self->priv->_label = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, validation_message_properties[VALIDATION_MESSAGE_LABEL_PROPERTY]);
	}
}

static GObject *
validation_message_constructor (GType type,
                                guint n_construct_properties,
                                GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	ValidationMessage * self;
	const gchar* _tmp0_;
	GtkLabel* _tmp1_ = NULL;
	GtkLabel* _tmp2_;
	GtkStyleContext* _tmp3_;
	GtkLabel* _tmp4_;
	GtkLabel* _tmp5_;
	parent_class = G_OBJECT_CLASS (validation_message_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_VALIDATION_MESSAGE, ValidationMessage);
	_tmp0_ = self->priv->_label;
	_tmp1_ = (GtkLabel*) gtk_label_new (_tmp0_);
	gtk_widget_set_halign ((GtkWidget*) _tmp1_, GTK_ALIGN_END);
	gtk_label_set_justify (_tmp1_, GTK_JUSTIFY_RIGHT);
	gtk_label_set_max_width_chars (_tmp1_, 55);
	g_object_set (_tmp1_, "wrap", TRUE, NULL);
	gtk_label_set_xalign (_tmp1_, (gfloat) 1);
	g_object_ref_sink (_tmp1_);
	_g_object_unref0 (self->label_widget);
	self->label_widget = _tmp1_;
	_tmp2_ = self->label_widget;
	_tmp3_ = gtk_widget_get_style_context ((GtkWidget*) _tmp2_);
	gtk_style_context_add_class (_tmp3_, GRANITE_STYLE_CLASS_SMALL_LABEL);
	gtk_revealer_set_transition_type ((GtkRevealer*) self, GTK_REVEALER_TRANSITION_TYPE_CROSSFADE);
	_tmp4_ = self->label_widget;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp4_);
	_tmp5_ = self->label_widget;
	g_object_bind_property_with_closures ((GObject*) self, "label", (GObject*) _tmp5_, "label", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	return obj;
}

static void
validation_message_class_init (ValidationMessageClass * klass,
                               gpointer klass_data)
{
	validation_message_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &ValidationMessage_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_validation_message_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_validation_message_set_property;
	G_OBJECT_CLASS (klass)->constructor = validation_message_constructor;
	G_OBJECT_CLASS (klass)->finalize = validation_message_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALIDATION_MESSAGE_LABEL_PROPERTY, validation_message_properties[VALIDATION_MESSAGE_LABEL_PROPERTY] = g_param_spec_string ("label", "label", "label", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
}

static void
validation_message_instance_init (ValidationMessage * self,
                                  gpointer klass)
{
	self->priv = validation_message_get_instance_private (self);
}

static void
validation_message_finalize (GObject * obj)
{
	ValidationMessage * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_VALIDATION_MESSAGE, ValidationMessage);
	_g_object_unref0 (self->label_widget);
	_g_free0 (self->priv->_label);
	G_OBJECT_CLASS (validation_message_parent_class)->finalize (obj);
}

static GType
validation_message_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ValidationMessageClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) validation_message_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValidationMessage), 0, (GInstanceInitFunc) validation_message_instance_init, NULL };
	GType validation_message_type_id;
	validation_message_type_id = g_type_register_static (gtk_revealer_get_type (), "ValidationMessage", &g_define_type_info, 0);
	ValidationMessage_private_offset = g_type_add_instance_private (validation_message_type_id, sizeof (ValidationMessagePrivate));
	return validation_message_type_id;
}

GType
validation_message_get_type (void)
{
	static volatile gsize validation_message_type_id__volatile = 0;
	if (g_once_init_enter (&validation_message_type_id__volatile)) {
		GType validation_message_type_id;
		validation_message_type_id = validation_message_get_type_once ();
		g_once_init_leave (&validation_message_type_id__volatile, validation_message_type_id);
	}
	return validation_message_type_id__volatile;
}

static void
_vala_validation_message_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec)
{
	ValidationMessage * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_VALIDATION_MESSAGE, ValidationMessage);
	switch (property_id) {
		case VALIDATION_MESSAGE_LABEL_PROPERTY:
		g_value_set_string (value, validation_message_get_label (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_validation_message_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec)
{
	ValidationMessage * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_VALIDATION_MESSAGE, ValidationMessage);
	switch (property_id) {
		case VALIDATION_MESSAGE_LABEL_PROPERTY:
		validation_message_set_label (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

